<id>
ErrorLog Security YaBB 2611
</id>

<version>
0.2
</version>

<mod info>
This mod adds extra anti-spam features to the errorlog Admin section - auto-ban IPs with repeated errors in .htaccess

Version History
---------------
0.1 - First release - Oct 08, 2014
0.2 - Updated for 2.6.11 - Dec 15, 2014

For YaBB 2.6.11

Instructions:

Apply the mod and upload (in ASCII mode):

cgi-bin/yabb2/Admin/Modlist.pm
cgi-bin/yabb2/Admin/NewSettings.pm
cgi-bin/yabb2/Admin/Settings_Antispam.pm
cgi-bin/yabb2/Languages/English/Admin.lng
cgi-bin/yabb2/Sources/Subs.pm
</mod info>

<author>
Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $errorlog_security = q~ErrorLog Security for 2.6.11|Dandello|adds extra anti-spam features to the errorlog Admin section - auto-ban IPs with repeated errors in .htaccess|0.2|12/15/14~;
    push @installed_mods, $errorlog_security;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
1;
EOF
</search for>

<add before>
\$error_spd = $error_spd;                   # Minimum time in seconds between error log entries from the same IP address.

</add before>

<edit file>
Admin/Settings_AntiSpam.pm
</edit file>

<search for>
            { header => $settings_txt{'spambot'}, },
</search for>

<add before>
            {
                description =>
                  qq~<label for="error_spd">$admin_txt{'error_spd'}</label>~,
                input_html =>
qq~<input type="text" name="error_spd" id="error_spd" size="4" value="$error_spd" />~,
                name     => 'error_spd',
                validate => 'number',
            },
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
$admin_txt{'error_spd'} = q~ErrorLog speed banning. Minimum number of seconds between multiple error log entries from the same IP address. <br /><span class="small">Violators are banned through .htaccess if allowed. Set to '0' to disable</span>~;

</add before>

<edit file>
Sources/Subs.pm
</edit file>

<search for>
    if ($iamguest) {
        push @errorlog,
</search for>

<replace>
    if ($iamguest ) {
        if ( $error_spd > 0 ) {
            @erloga = split /[|]/xsm, $errorlog[-1];
            @erlogb = split /[|]/xsm, $errorlog[$#errorlog-1];
            if ($erloga[2] eq $user_ip && $erlogb[2] eq $user_ip && ($erloga[1] - $erlogb[1]) < $error_spd && ( $date - $erloga[1] ) < $error_spd ) {
                require Admin::ErrorLog;
                update_htaccess( 'add', $user_ip );
                $tmperror .= q~<br />IP blocked~;
            }
        }
        push @errorlog,
</replace>
